
exports.up = function (knex, Promise) {
    return knex.schema.createTable('messages_questions', function (table) {
        table.integer('mid').primary().notNullable() //(non-nullable) primary key
            .references('mid').inTable('messages')
            .onDelete('CASCADE'); 
        table.timestamps(true, true); //adds timestamptz-type (a PostgresQL data type) updated_at and created_at columns

        table.string('title').notNullable();
        table.text('content').notNullable();

        table.string('recipient', 128)
            .references('gid').inTable('groups')
            .onDelete('SET NULL'); //if recipient is deleted, direct to null
        table.string('author')
            .references('uid').inTable('users')
            .onDelete('SET NULL'); //must refer to a User's uid.

        /* 
        we cannot declare this column yet, as table 'answers' is not yet created.
        it will be declared in the migration for the 'answers' childtable.
        table.integer('for_answer')
            .references('mid').inTable('answers')
            .onDelete('SET NULL'); //if answer is deleted, set for_answer to null
        */
    });
};

exports.down = function (knex, Promise) {
    return knex.schema.dropTable('messages_questions');
};
